## sra-sdk 2.3.5

=== Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================


#-------------------------------------------------------------------------------
# environment
#
TOP ?= $(CURDIR)
include $(TOP)/build/Makefile.shell


#-------------------------------------------------------------------------------
# default
#
SUBDIRS = \
	libs \
	tools

# common targets for non-leaf Makefiles; must follow a definition of SUBDIRS
include $(TOP)/build/Makefile.targets

default: $(SUBDIRS)

test: $(SUBDIRS)

$(SUBDIRS) test:
	@ $(MAKE) -C $@

.PHONY: default $(SUBDIRS) test

#-------------------------------------------------------------------------------
# all
#
$(SUBDIRS_ALL):

#-------------------------------------------------------------------------------
# std
#
$(SUBDIRS_STD):

#-------------------------------------------------------------------------------
# clean
#
clean: clean_test

clean_test:

#-------------------------------------------------------------------------------
# pass-through targets
#
COMPILERS = GCC VC++ CLANG
ARCHITECTURES = i386 x86_64 sparc32 sparc64
CONFIG = debug profile release static dynamic
PUBLISH = scm pubtools
REPORTS = bindir targdir osdir config compilers architecture architectures
PASSTHRUS = \
	out \
	CC $(COMPILERS) \
	$(ARCHITECTURES) \
	$(CONFIG) $(PUBLISH)

$(PASSTHRUS):
	@ $(MAKE) -s TOP=$(CURDIR) -f build/Makefile.env $@
	@ $(MAKE) -s TOP=$(CURDIR) -f build/Makefile.env rebuild-dirlinks config

$(REPORTS):
	@ $(MAKE) -s TOP=$(CURDIR) -f build/Makefile.env $@

.PHONY: $(PASSTHRUS) $(REPORTS)


#-------------------------------------------------------------------------------
# configuration help
#
help configure:
	@ echo "Before initial build, run 'make OUTDIR=<dir> out' from"
	@ echo "the project root to set the output directory of your builds."
	@ echo
	@ echo "To select a compiler, run 'make <comp>' where"
	@ echo "comp = { "$(COMPILERS)" }."
	@ echo
	@ echo "For hosts that support cross-compilation ( only Macintosh today ),"
	@ echo "you can run 'make <arch>' where arch = { "$(ARCHITECTURES)" }."
	@ echo
	@ echo "To set a build configuration, run 'make <config>' where"
	@ echo "config = { "$(CONFIG)" }."
	@ echo

.PHONY: help configure

=== libs/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================


TOP ?= $(shell ../build/abspath.sh ..)
MODULE = libs

include $(TOP)/build/Makefile.shell

#-------------------------------------------------------------------------------
# default
#
SUBDIRS = \
	ext \
	klib \
	kproc \
	kfs \
	kns \
	kxml \
	kfg \
	krypto \
	vfs \
	kapp \
	kdb \
	vdb \
	vxf \
	search \
	sraxf \
	align \
	axf \
	wgsxf \
	ktst \
	loader \
	blast \
	ascp \
	sra \
	ncbi-vdb


# common targets for non-leaf Makefiles; must follow a definition of SUBDIRS
include $(TOP)/build/Makefile.targets

$(SUBDIRS):
	@ $(MAKE) -C $@

.PHONY: default $(SUBDIRS)

#-------------------------------------------------------------------------------
# pass-through
#
out debug profile release GCC ICC VC++:
	@ $(MAKE) TOP=$(TOP) -f $(TOP)/build/Makefile.env $@

.PHONY: out debug profile release GCC ICC VC++

=== tools/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================


TOP ?= $(shell ../build/abspath.sh ..)
MODULE = tools

include $(TOP)/build/Makefile.shell


#-------------------------------------------------------------------------------
# default
#
SUBDIRS = \
	util \
	kar \
	vdb-dump \
	sra-dump \
	sra-load \
	sra-pileup \
	bam-loader \
	fastq-loader \
	srapath \
	sra-stat \
	vdb-copy \
	vdb-config \
	align-info \
	prefetch \
	nenctool \
	nencvalid \
	vdb-decrypt \
	vdb-validate \
	sra-sort \
    cache-mgr

# common targets for non-leaf Makefiles; must follow a definition of SUBDIRS
include $(TOP)/build/Makefile.targets

$(SUBDIRS):
	@ $(MAKE) -C $@

.PHONY: default $(SUBDIRS) 

#-------------------------------------------------------------------------------
# pass-through
#
out debug profile release GCC ICC VC++:
	@ $(MAKE) TOP=$(TOP) -f $(TOP)/build/Makefile.env $@

.PHONY: out debug profile release GCC ICC VC++

=== libs/align/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================


default: std

TOP ?= $(shell ../../build/abspath.sh ../..)
MODULE = libs/align

INT_LIBS = \
	libncbi-bam \
	libalign-writer \
	libalign-access \
	libalign-reader

ALL_LIBS = \
	$(INT_LIBS)

include $(TOP)/build/Makefile.env

#-------------------------------------------------------------------------------
# outer targets
#
all std: makedirs
	@ $(MAKE_CMD) $(TARGDIR)/std

$(INT_LIBS): makedirs
	@ $(MAKE_CMD) $(ILIBDIR)/$@

.PHONY: all std $(ALL_LIBS)

#-------------------------------------------------------------------------------
# std
#
$(TARGDIR)/std: \
	$(addprefix $(ILIBDIR)/,$(INT_LIBS))

.PHONY: $(TARGDIR)/std

#-------------------------------------------------------------------------------
# clean
#
clean: stdclean

.PHONY: clean

#-------------------------------------------------------------------------------
# libncbi-bam
#
$(ILIBDIR)/libncbi-bam: $(addprefix $(ILIBDIR)/libncbi-bam.,$(ILIBEXT))

BAM_SRC = \
	bam

BAM_OBJ = \
	$(addsuffix .$(LOBX),$(BAM_SRC))

BAM_LIB = 

$(ILIBDIR)/libncbi-bam.$(LIBX): $(BAM_OBJ)
	$(LD) --slib -o $@ $^ $(BAM_LIB)


#-------------------------------------------------------------------------------
# align-access
#
$(ILIBDIR)/libalign-access: $(addprefix $(ILIBDIR)/libalign-access.,$(ILIBEXT))

ALIGN_ACCESS_SRC = \
	align-access

ALIGN_ACCESS_OBJ = \
	$(addsuffix .$(LOBX),$(ALIGN_ACCESS_SRC))

ALIGN_ACCESS_LIB = 

$(ILIBDIR)/libalign-access.$(LIBX): $(ALIGN_ACCESS_OBJ)
	$(LD) --slib -o $@ $^ $(ALIGN_ACCESS_LIB)

#-------------------------------------------------------------------------------
# align-reader
#
$(ILIBDIR)/libalign-reader: $(addprefix $(ILIBDIR)/libalign-reader.,$(ILIBEXT))

ALIGN_READER_SRC = \
	align_mgr \
	al_iterator \
	ref_iterator \
	pl_iterator \
	dna-reverse-cmpl \
	reference-cmn \
	reader-cmn \
	reader-refseq \
	reference \
	refseq-mgr \
	quality-quantizer

ALIGN_READER_OBJ = \
	$(addsuffix .$(LOBX),$(ALIGN_READER_SRC))

ALIGN_READER_LIB = 

$(ILIBDIR)/libalign-reader.$(LIBX): $(ALIGN_READER_OBJ)
	$(LD) --slib -o $@ $^ $(ALIGN_READER_LIB)

#-------------------------------------------------------------------------------
# align-writer
#
$(ILIBDIR)/libalign-writer: $(addprefix $(ILIBDIR)/libalign-writer.,$(LIBX))

ALIGN_WRITER_SRC = \
    dna-reverse-cmpl \
	reader-cmn \
	reference-cmn \
	reader-refseq \
	refseq-mgr \
	writer-cmn \
	writer-refseq \
	writer-alignment \
	writer-sequence \
	writer-ref \
	writer-reference

ALIGN_WRITER_OBJ = \
	$(addsuffix .$(LOBX),$(ALIGN_WRITER_SRC))

ALIGN_WRITER_LIB = 

$(ILIBDIR)/libalign-writer.$(LIBX): $(ALIGN_WRITER_OBJ)
	$(LD) --slib -o $@ $^ $(ALIGN_WRITER_LIB)

=== libs/ascp/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================


default: std

TOP ?= $(shell ../../build/abspath.sh ../..)
MODULE = libs/ascp

INT_LIBS = \
    libascp

ALL_LIBS = \
	$(INT_LIBS)

include $(TOP)/build/Makefile.env

#-------------------------------------------------------------------------------
# outer targets
#
all std: makedirs
	@ $(MAKE_CMD) $(TARGDIR)/std

$(INT_LIBS): makedirs
	@ $(MAKE_CMD) $(ILIBDIR)/$@

.PHONY: all std $(ALL_LIBS)

#-------------------------------------------------------------------------------
# std
#
$(TARGDIR)/std: \
	$(addprefix $(ILIBDIR)/,$(INT_LIBS))

.PHONY: $(TARGDIR)/std

#-------------------------------------------------------------------------------
# clean
#
clean: stdclean

.PHONY: clean

#-------------------------------------------------------------------------------
# testing framework
#
$(ILIBDIR)/libascp: $(addprefix $(ILIBDIR)/libascp.,$(LIBX))

SRC = \
	ascp \
	ascp-path \
	connect
#	silent-system

OBJ = \
	$(addsuffix .$(LOBX),$(SRC))

$(ILIBDIR)/libascp.$(LIBX): $(OBJ)
	$(LD) --slib -o $@ $^ $(LIB)

=== libs/axf/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================


default: std

TOP ?= $(shell ../../build/abspath.sh ../..)
MODULE = libs/axf

INT_LIBS = \
	libaxf \
	libwaxf

ALL_LIBS = \
	$(INT_LIBS)

include $(TOP)/build/Makefile.env

#-------------------------------------------------------------------------------
# outer targets
#
all std: makedirs
	@ $(MAKE_CMD) $(TARGDIR)/std

$(ALL_LIBS): makedirs
	@ $(MAKE_CMD) $(TARGDIR)/$@

.PHONY: all std $(ALL_LIBS)

#-------------------------------------------------------------------------------
# std
#
$(TARGDIR)/std: \
	$(addprefix $(TARGDIR)/,$(ALL_LIBS))

.PHONY: $(TARGDIR)/all $(TARGDIR)/std

#-------------------------------------------------------------------------------
# clean
#
clean: stdclean

.PHONY: clean

#-------------------------------------------------------------------------------
# alignment transform library
#
$(TARGDIR)/libaxf: $(addprefix $(ILIBDIR)/libaxf.,$(ILIBEXT))

AXF_SRC = \
	ref-tbl-sub-select \
	ref-restore-read \
	align-restore-read \
	raw-restore-read \
	raw-restore-qual \
	seq-restore-read \
	seq-construct-read \
	cigar \
	project_read_from_sequence \
	not-my-row \
	template-len \
	get-sam-flags \
	align-ref-pos \
	align-ref-name \
	align-ref-seq-id \
	align-local_ref_id \
	align-local_ref_start \
	generate-mismatch-qual \
	mismatch-restore-qual \
	ref-preserve_qual \
	ref-tbl \
	make-cmp-read_desc \
	get_mate_align_ids

AXF_OBJ = \
	$(addsuffix .$(LOBX),$(AXF_SRC))

AXF_LIB = \
	-lalign-reader \
	-dvdb \
	-dkdb \
	-dklib \
	-dm \
	-dz

$(ILIBDIR)/libaxf.$(LIBX): $(AXF_OBJ)
	$(LD) --slib -o $@ $^ $(AXF_LIB)


#-------------------------------------------------------------------------------
# alignment transform update library
#
$(TARGDIR)/libwaxf: $(addprefix $(ILIBDIR)/libwaxf.,$(ILIBEXT))

WAXF_SRC = \
	$(AXF_SRC) \
	refseq-stats

WAXF_OBJ = \
	$(addsuffix .$(LOBX),$(WAXF_SRC))

WAXF_LIB = \
	-lalign-reader \
	-dwvdb \
	-dwkdb \
	-lkfg \
	-dklib \
	-dm \
	-dz

$(ILIBDIR)/libwaxf.$(LIBX): $(WAXF_OBJ)
	$(LD) --slib -o $@ $^ $(WAXF_LIB)

=== libs/blast/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

default: all

TOP ?= $(abspath ../..)

MODULE = libs/blast

INT_LIBS = \

ALL_LIBS = \
	$(INT_LIBS) \
	$(EXT_LIBS)

include $(TOP)/build/Makefile.env

ifeq (linux,$(OS))
ifeq (64,$(BITS))
	INT_LIBS += libvdb-blast
endif    
endif    

#-------------------------------------------------------------------------------
# outer targets
#
all std: makedirs
	@ $(MAKE_CMD) $(TARGDIR)/std

$(INT_LIBS): makedirs
	@ $(MAKE_CMD) $(ILIBDIR)/$@

.PHONY: all std $(ALL_LIBS)

#-------------------------------------------------------------------------------
# std
#
$(TARGDIR)/std: \
	$(addprefix $(ILIBDIR)/,$(INT_LIBS))

.PHONY: $(TARGDIR)/std

#-------------------------------------------------------------------------------
# clean
#
clean: stdclean

.PHONY: clean

#-------------------------------------------------------------------------------
# blast
#
$(ILIBDIR)/libvdb-blast: $(addprefix $(ILIBDIR)/libvdb-blast.,$(ILIBEXT))

BLAST_SRC = \
	blast \

BLAST_OBJ = \
	$(addsuffix .$(LOBX),$(BLAST_SRC))

BLAST_LIB = \

$(ILIBDIR)/libvdb-blast.$(LIBX): $(BLAST_OBJ)
	$(LD) --slib -o $@ $^ $(BLAST_LIB)

=== libs/kapp/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================


default: std

TOP ?= $(shell ../../build/abspath.sh ../..)
MODULE = libs/kapp

include $(TOP)/build/Makefile.env

INT_LIBS = \
	libkapp \
    libload

ALL_LIBS = \
	$(INT_LIBS)

#-------------------------------------------------------------------------------
# outer targets
#
all std: makedirs
	@ $(MAKE_CMD) $(TARGDIR)/std

$(INT_LIBS): makedirs
	@ $(MAKE_CMD) $(ILIBDIR)/$@

.PHONY: all std $(ALL_LIBS)

#-------------------------------------------------------------------------------
# std
#
$(TARGDIR)/std: \
	$(addprefix $(ILIBDIR)/,$(INT_LIBS))

.PHONY: $(TARGDIR)/std

#-------------------------------------------------------------------------------
# clean
#
clean: stdclean

.PHONY: clean

#-------------------------------------------------------------------------------
# OS specific application support
#
$(ILIBDIR)/libkapp: $(addprefix $(ILIBDIR)/libkapp.,$(LIBX))

KAPP_SRC = \
	main \
	args \
	tokenizer \
	sysmain

KAPP_OBJ = \
	$(addsuffix .$(OBJX),$(KAPP_SRC))

KAPP_LIB = \
	-dvfs \
	-dklib

$(ILIBDIR)/libkapp.$(LIBX): $(KAPP_OBJ)
	$(LD) --slib -o $@ $^ $(KAPP_LIB)


#-------------------------------------------------------------------------------
# loaders common libarary
#
$(ILIBDIR)/libload: $(addprefix $(ILIBDIR)/libload.,$(LIBX))

LOADLIB_SRC = \
	progressbar \
	loader-file \
	loader-meta \
	log-xml

ifneq (win,$(OS))
	LOADLIB_SRC += queue-file
endif

LOADLIB_OBJ = \
	$(addsuffix .$(LOBX),$(LOADLIB_SRC))

LOADLIB_LIB = \
	-dkfs \
	-dklib

ifneq (win,$(OS))
	LOADLIB_LIB += -dkq
endif

$(ILIBDIR)/libload.$(LIBX): $(LOADLIB_OBJ)
	$(LD) --slib -o $@ $^ $(LOADLIB_LIB)

=== libs/kdb/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================


default: std

TOP ?= $(shell ../../build/abspath.sh ../..)
MODULE = libs/kdb

INT_LIBS = \
	libkdb \
	libwkdb

ALL_LIBS = \
	$(INT_LIBS)

include $(TOP)/build/Makefile.env

#-------------------------------------------------------------------------------
# outer targets
#
all std: makedirs
	@ $(MAKE_CMD) $(TARGDIR)/std

$(INT_LIBS): makedirs
	@ $(MAKE_CMD) $(ILIBDIR)/$@

.PHONY: all std $(ALL_LIBS) $(ALL_DEFS)


#-------------------------------------------------------------------------------
# std
#
$(TARGDIR)/std: \
	$(addprefix $(ILIBDIR)/,$(INT_LIBS))

.PHONY: $(TARGDIR)/std

#-------------------------------------------------------------------------------
# clean
#
clean: stdclean

.PHONY: clean

#-------------------------------------------------------------------------------
# kdb
#
$(ILIBDIR)/libkdb: $(addprefix $(ILIBDIR)/libkdb.,$(ILIBEXT))

KDB_CMN = \
	btree \
	dbmgr-cmn \
#	database-cmn

KDB_SRC = \
	$(KDB_CMN) \
	kdb \
	dbmgr \
	dbcc-cmn \
	database \
	database-cc \
	table \
	table-cc \
	column \
	column-cc \
	coldata \
	colidx \
	colidx0 \
	colidx1 \
	colidx2 \
	idxblk \
	meta \
	index \
	idstats \
	trieidx-v1 \
	trieval-v1 \
	ptrieval-v1 \
	trieidx-v2 \
	trieval-v2 \
	ptrieval-v2 \
	u64idx-v3

KDB_OBJ = \
	$(addsuffix .$(LOBX),$(KDB_SRC))

KDB_LIB = \
	-dvfs \
	-dkrypto \
	-dkfs \
	-dklib

$(ILIBDIR)/libkdb.$(LIBX): $(KDB_OBJ)
	$(LD) --slib -o $@ $^ $(KDB_LIB)


#-------------------------------------------------------------------------------
# wkdb
#
$(ILIBDIR)/libwkdb: $(addprefix $(ILIBDIR)/libwkdb.,$(ILIBEXT))

WKDB_SRC = \
	$(KDB_CMN) \
	wkdb \
	wdbmgr \
	wdatabase \
	wtable \
	wcolumn \
	wcoldata \
	wcolidx \
	wcolidx0 \
	wcolidx1 \
	wcolidx2 \
	idxblk \
	widxblk \
	wmeta \
	windex \
	wtrieidx-v1 \
	wtrieidx-v2 \
	wu64idx-v3

WKDB_OBJ = \
	$(addsuffix .$(LOBX),$(WKDB_SRC))

WKDB_LIB = \
	-dvfs \
	-dkrypto \
	-dkfs \
	-dklib

$(ILIBDIR)/libwkdb.$(LIBX): $(WKDB_OBJ)
	$(LD) --slib -o $@ $^ $(WKDB_LIB)

=== libs/kfg/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

default: all

TOP ?= $(shell ../../build/abspath.sh ../..)
MODULE = libs/kfg

INT_LIBS = \
	libkfg

ALL_LIBS = \
	$(INT_LIBS)

include $(TOP)/build/Makefile.env

#-------------------------------------------------------------------------------
# outer targets
#
all std: makedirs
	@ $(MAKE_CMD) $(TARGDIR)/std

$(INT_LIBS): makedirs
	@ $(MAKE_CMD) $(ILIBDIR)/$@

.PHONY: all std $(ALL_LIBS)

#-------------------------------------------------------------------------------
# std
#
$(TARGDIR)/std: \
	$(addprefix $(ILIBDIR)/,$(INT_LIBS))

.PHONY: $(TARGDIR)/std

#-------------------------------------------------------------------------------
# clean
#
clean: stdclean

.PHONY: clean

#-------------------------------------------------------------------------------
# kfg
#
$(ILIBDIR)/libkfg: $(TARGDIR)/default.kfg $(addprefix $(ILIBDIR)/libkfg.,$(ILIBEXT))

$(TARGDIR)/default.kfg: $(NCBIDIR)/default.kfg $(TEST_BINDIR)/ncbi/default.kfg

$(NCBIDIR)/default.kfg: $(SRCDIR)/default.kfg
	rm -f $(NCBIDIR)/config.kfg
	cp $^ $@

ifneq ($(NCBIDIR),$(TEST_BINDIR)/ncbi)
$(TEST_BINDIR)/ncbi/default.kfg: $(SRCDIR)/default.kfg
	mkdir -p $(TEST_BINDIR)/ncbi
	cp $^ $@
endif

KFG_SRC = \
	config-grammar \
	config-lex \
	config \
	kart \
	repository \
	report-kfg \
    keystore 

KFG_OBJ = \
	$(addsuffix .$(LOBX),$(KFG_SRC))

KFG_LIB = \
	-dkfs \
	-dklib

$(ILIBDIR)/libkfg.$(LIBX): $(INTERM_SRC) $(KFG_OBJ)
	$(LD) --slib -o $@ $^ $(KFG_LIB)

=== libs/kfs/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

default: all

TOP ?= $(shell ../../build/abspath.sh ../..)
MODULE = libs/kfs

INT_LIBS = \
	libkfs \
	libkfs-nommap

ALL_LIBS = \
	$(INT_LIBS)

include $(TOP)/build/Makefile.env

#-------------------------------------------------------------------------------
# outer targets
#
all std: makedirs
	@ $(MAKE_CMD) $(TARGDIR)/std

$(INT_LIBS): makedirs
	@ $(MAKE_CMD) $(ILIBDIR)/$@

.PHONY: all std $(ALL_LIBS)

#-------------------------------------------------------------------------------
# std
#
$(TARGDIR)/std: \
	$(addprefix $(ILIBDIR)/,$(INT_LIBS))

.PHONY: $(TARGDIR)/std

#-------------------------------------------------------------------------------
# clean
#
clean: stdclean

.PHONY: clean

#-------------------------------------------------------------------------------
# mmap.c
#  special rule to generate a disabled mmap
#
%.nommap.$(LOBX): %.c
	$(CC) -o $@ -fPIC $(OPT) -DFORCE_MALLOC_MMAP -D_LIBRARY $<


#-------------------------------------------------------------------------------
# kfs
#
$(ILIBDIR)/libkfs: $(addprefix $(ILIBDIR)/libkfs.,$(ILIBEXT))

$(ILIBDIR)/libkfs-nommap: $(addprefix $(ILIBDIR)/libkfs-nommap.,$(LIBX))

KFS_CMN = \
	directory \
	arrayfile \
	file \
	sysdir \
	sysfile \
	sysmmap \
	syslockfile \
	sysdll \
	gzip \
	bzip \
	md5 \
	crc32 \
	arc \
	toc \
	tocentry \
	tocdir \
	tocfile \
	sra \
	tar \
	teefile \
	buffile \
	buffile-read \
	buffile-write \
	subfile \
	nullfile \
	countfile \
	dir_test \
	pagefile \
	pmem \
	readheadfile \
	ramfile \
	quickmount \
	report \
	lockfile \
	syslockfile \
	cacheteefile \
	from_to_namelist \

KFS_SRC = \
	mmap \
	$(KFS_CMN)

ifeq (win,$(OS))
	KFS_SRC += directory-path
endif

KFS_NOMMAP_SRC = \
	mmap.nommap \
	$(KFS_CMN)

KFS_OBJ = \
	$(addsuffix .$(LOBX),$(KFS_SRC))

KFS_NOMMAP_OBJ = \
	$(addsuffix .$(LOBX),$(KFS_NOMMAP_SRC))

KFS_LIB = \
	-dkproc \
	-dklib \
	-ddl \
	-dz \
	-dbz2

$(ILIBDIR)/libkfs.$(LIBX): $(KFS_OBJ)
	$(LD) --slib -o $@ $^ $(KFS_LIB)

$(ILIBDIR)/libkfs-nommap.$(LIBX): $(KFS_NOMMAP_OBJ)
	$(LD) --slib -o $@ $^ $(KFS_LIB)


#-------------------------------------------------------------------------------
# kff
#
ifeq (linux,$(OS))
$(ILIBDIR)/libkff: $(addprefix $(ILIBDIR)/libkff.,$(ILIBEXT))
else
$(ILIBDIR)/libkff:
	@ echo "not building libkff on "$(OS)
endif

KFF_SRC = \
	fileformat \
	ffext \
	ffkey \
	ffmagic

KFF_OBJ = \
	$(addsuffix .$(LOBX),$(KFF_SRC))

KFF_LIB = \
	-dkfg \
	-dklib

ifneq (win,$(OS))
	KFF_LIB += -lmagic
endif

$(ILIBDIR)/libkff.$(LIBX): $(KFF_OBJ)
	$(LD) --slib -o $@ $^ $(KFF_LIB)

=== libs/klib/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================


default: all

TOP ?= $(shell ../../build/abspath.sh ../..)
MODULE = libs/klib

INT_LIBS = \
	libklib

ALL_LIBS = \
	$(INT_LIBS)

include $(TOP)/build/Makefile.env

#-------------------------------------------------------------------------------
# outer targets
#
all: makedirs
	@ $(MAKE) -C $(SRCDIR)/judy all
	@ $(MAKE_CMD) $(TARGDIR)/all

std: makedirs
	@ $(MAKE) -C $(SRCDIR)/judy std
	@ $(MAKE_CMD) $(TARGDIR)/std

$(INT_LIBS): makedirs
	@ $(MAKE) -C $(SRCDIR)/judy std
	@ $(MAKE_CMD) $(ILIBDIR)/$@

.PHONY: all std $(ALL_LIBS)

#-------------------------------------------------------------------------------
# all, std
#
$(TARGDIR)/all $(TARGDIR)/std: \
	$(addprefix $(ILIBDIR)/,$(INT_LIBS))

.PHONY: $(TARGDIR)/all $(TARGDIR)/std

#-------------------------------------------------------------------------------
# clean
#
clean: stdclean
	@ $(MAKE) -C $(SRCDIR)/judy clean

.PHONY: clean

#-------------------------------------------------------------------------------
# klib
#
$(ILIBDIR)/libklib: $(addprefix $(ILIBDIR)/libklib.,$(ILIBEXT))

KLIB_SRC = \
	text \
	utf8 \
	iso8859 \
	iso8859-1 \
	cp1252 \
	token \
	symtab \
	container \
	vector \
	namelist \
	vector_namelist \
	trie \
	pbstree \
	pbstree-impl.nopt \
	pbstree-impl.swap.nopt \
	bstpersist.nopt \
	ptrie.nopt \
	ptpersist.nopt \
	crc32 \
	md5 \
	misc \
	SHA-32bit \
	SHA-64bit \
	qsort \
	ksort \
	bsearch \
	pack \
	unpack \
	vlen-encode \
	data-buffer \
	refcount \
	printf \
	status-rc-strings \
	status-rc \
	syserrcode \
	syswriter \
	out \
	status \
	log \
	writer \
	syslog \
	systime \
	rc-tbl \
	rc-idx-tbl \
	judy-vector \
	report \
	sra-release-version

ifeq (win,$(OS))
	KLIB_SRC += sysalloc
endif

ifeq (dbg,$(BUILD))
	KLIB_SRC += debug
endif

KLIB_OBJ = \
	$(addsuffix .$(LOBX),$(KLIB_SRC))

KLIB_LIB = \
	-sjudy \
	-lm

$(ILIBDIR)/libklib.$(LIBX): $(KLIB_OBJ)
	$(LD) --slib -o $@ $^ $(KLIB_LIB)

## sra-sdk 2.3.5-2+dfsg

=== debian/changelog ===
sra-sdk (2.3.5-2+dfsg-1ubuntu1) vivid; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - debian/control: Limit to amd64 and i386 due to some assembly.

 -- Logan Rosen <logan@ubuntu.com>  Tue, 04 Nov 2014 17:14:18 -0500

sra-sdk (2.3.5-2+dfsg-1) unstable; urgency=medium

  * New upstream version
  * d/rules: Adapt get-orig-source target to new uscan implementation
  * d/watch: use uversionmangle to get properly named download tarball

 -- Andreas Tille <tille@debian.org>  Wed, 30 Jul 2014 13:52:45 +0200

=== debian/control ===
Source: sra-sdk
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Charles Plessy <plessy@debian.org>,
           Andreas Tille <tille@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper (>= 9),
               libbz2-dev,
               zlib1g-dev,
               libxml2-dev
Standards-Version: 3.9.5
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=debian-med/sra-sdk.git
Vcs-Git: git://anonscm.debian.org/debian-med/sra-sdk.git
Homepage: http://trace.ncbi.nlm.nih.gov/Traces/sra/sra.cgi?view=software

Package: sra-toolkit
Architecture: amd64 i386
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: utilities for the NCBI Sequence Read Archive
 Tools for reading the SRA archive, generally by converting individual runs
 into some commonly used format such as fastq.
 .
 The textual dumpers "sra-dump" and "vdb-dump" are provided in this
 release as an aid in visual inspection. It is likely that their
 actual output formatting will be changed in the near future to a
 stricter, more formalized representation[s]. PLEASE DO NOT RELY UPON
 THE OUTPUT FORMAT SEEN IN THIS RELEASE.
 .
 The "help" information will be improved in near future releases, and
 the tool options will become standardized across the set. More documentation
 will also be provided documentation on the NCBI web site.
 .
 Tool options may change in the next release. Version 1 tool options
 will remain supported wherever possible in order to preserve
 operation of any existing scripts.

Package: sra-toolkit-libs0
Architecture: amd64 i386
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Libraries for the SRA Toolkit
 This package provides all libraries and modules for executing the
 NCBI SRA toolkit's programs.  This currently includes:
 .
  libkdb                # physical layer reading library
  libkfg                # configuration library
  libkfs                # file system library
  libklib               # support library
  libkproc              # process synchronization library
  libkq                 # cross-thread queue library
  libksproc             # single-threaded emulation library
  libksrch              # search algorithm library
  libkxfs               # XML to filesystem library
  libkxml               # XML container support library
  libload               # loader tool utility library
  libsra-schema         # weak-linked sra schema
  libsradb              # API for accessing sra
  libsrapath            # weak-link stubs for srapath
  libsrareader          # reader library
  libvdb                # virtual layer reading library
  libwkdb               # physical layer update library
  libwsradb             # update API for SRA
  libwvdb               # virtual layer update library

Package: sra-toolkit-libs-dev
Architecture: amd64 i386
Depends: ${shlibs:Depends},
         ${misc:Depends},
         sra-toolkit-libs0
Description: Development files for the NCBI SRA Toolkit's libraries
 This package provides development support files for the
 NCBI SRA Toolkit's libraries.

=== debian/rules ===
#!/usr/bin/make -f
%:
	dh $@

OUTDIR=$(CURDIR)/debian/tmp

override_dh_auto_clean:

override_dh_clean:
	dh_clean
	find libs/krypto -name "*.pic.o.list" -delete
	rm -f build/OUTDIR.linux

override_dh_auto_configure:
	export OUTDIR=$(OUTDIR) ; make OUTDIR=$(OUTDIR) out ; make release dynamic

override_dh_auto_build:
	export LD_LIBRARY_PATH="$$LD_LIBRARY_PATH:$(OUTDIR)/lib"; export OUTDIR=$(OUTDIR) ; make DEB_CFLAGS="$(CFLAGS)" DEB_LDFLAGS="$(LDFLAGS)"

override_dh_auto_test:

override_dh_prep:
	dh_prep -X debian/tmp

get-orig-source:
	uscan --verbose --force-download --repack --compression xz

=== debian/watch ===
version=3
opts=uversionmangle=s/$/+dfsg/ \
  http://trace.ncbi.nlm.nih.gov/Traces/sra/sra.cgi?view=software http://ftp-trace.ncbi.nlm.nih.gov/sra/sdk/.+?/sra_sdk-(.*)\.tar\.gz
